#!/usr/bin/env python

from mirra import main
from mirra.graphics import *
from mirra import utilities

""" Mirra : 2D graphic engine in OpenGL by www.ixi-software.net
    Check out documentation files
"""


class MirraApp(main.App):
    """ main appplication class, handles window contains events and graphics manager.
        Subclasses main.App and extends its public methods
    """
    def setUp(self):
        """ set here the main window properties and characteristics
        """
        self.caption = "mirra template" # window name
        self.size = 640, 480 #window size
        self.pos = 0,0 # window top left location
        self.fullScreen = 0 # if fullScreen is on it will overwrite your pos and size to match the display's resolution
        self.frameRate = 30 # set refresh framerate

    def start(self):
        """ First thing to happen after the instance has been initalisiated
            good place to instanciate classes and init stuff
        """
        Text('click anywhere to set me visible/invisible',80,80,1)
        self.r = Rect(200, 200, 1, 100, 100, color=(1,0,0))
        self.r.interactiveState=2 # draggable


    # other general app methods defined below
    # If no object trap this events then they get called
    def mouseDown(self, x,y):
        self.r.visible = not self.r.visible # toogle visibility





if __name__ == '__main__': MirraApp() # init always here your main app class that extends main.App










